use Config;
use File::Basename qw(basename dirname);
chdir(dirname($0));

$perl = shift(@ARGV);

$use = "use lib qw(\n\t" . join("\n\t", @ARGV) . ");\n";

($file = basename($0)) =~ s/\.PL$//;
$file =~ s/\.pl$//
	if ($Config{'osname'} eq 'VMS' or
	    $Config{'osname'} eq 'OS2');  # "case-forgiving"


open OUT,">$file" or die "Can't create $file: $!";
chmod(0755, $file);
print "Extracting $file (with variable substitutions)\n";

print OUT <<"!GROK!THIS!";
#!$perl -w

#
# Warning: File automatically generated. Any changes made here
# will be lost.
#

$use

##HeaderEnd

!GROK!THIS!
print OUT <<'!NO!SUBS!';

=head1 NAME

list-repositories

=head1 SYNOPSIS

list-repositories 

=head1 DESCRIPTION

See http://nhse.mcs.anl.gov/NHSE96/RIB/MTk/tools/list-repositories.htm
for a full description of this command.

=cut

use strict;

use MTk;

eval {
    &main;
};

if ($@)
{
    print "list-repositories failed:\n\t$@\n";
    exit(1);
}


exit(0);

sub main
{
    my($db);

    if (@ARGV == 0)
    {
    }
    else
    {
	die "Usage: $0\n";
    }

    $db = $MTk::DBClass->new();
    $db or die "Cannot connect to database\n";
    
    $db->open();

    &list_repositories($db);
}

#
# List the repositories...
# 

sub list_repositories
{
    my($db) = @_;
    my($q, $a);
    my($n, $on, $path, $url);

    $q = $db->query("SELECT name FROM Repository");

    if ($q)
    {
	for $a (@{$q->row_lists()})
	{
	    ($n)= @$a;
	    my $r = MTk::DBTable::Repository->new($n, $db);
	    $r->fetch();
	    $r->print();
	}
    }
}
!NO!SUBS!
