use Config;
use File::Basename qw(basename dirname);
chdir(dirname($0));

$perl = shift(@ARGV);

$use = "use lib qw(\n\t" . join("\n\t", @ARGV) . ");\n";

($file = basename($0)) =~ s/\.PL$//;
$file =~ s/\.pl$//
	if ($Config{'osname'} eq 'VMS' or
	    $Config{'osname'} eq 'OS2');  # "case-forgiving"


open OUT,">$file" or die "Can't create $file: $!";
chmod(0755, $file);
print "Extracting $file (with variable substitutions)\n";

print OUT <<"!GROK!THIS!";
#!$perl

#
# Warning: File automatically generated. Any changes made here
# will be lost.
#

$use

##HeaderEnd

!GROK!THIS!
print OUT <<'!NO!SUBS!';



use strict;

use File::Path;

use CGI;
use MTk;
use LWP::RobotUA;
use PageTemplate;
require SGS;

my $CGIBin = $MTk::cgi_bin_url;
$::TEMPLATE_DIR = "$MTk::install_lib/templates";


eval {
    &main;
};

if ($@)
{
    print "repos-admin failed:\n\t$@\n";
    exit(1);
}


exit(0);

sub main
{
    my($db, $asset_id, $repos_name);
    my($query);

    $query = new CGI;

    if ($ENV{'REQUEST_METHOD'} eq "GET")
    {
	$query->param("admin_top", "yes");
    }
    else
    {
	$repos_name = $query->param("repos_name");
	$asset_id = $query->param("asset_id");
    }
    

    print "Content-type: text/html\n\n";

    if ($query->param("admin_top") ne '')
    {
	$db = open_db();
	&admin_top($db);
    }
    elsif ($query->param("show_create_form") ne '')
    {
	&show_create_form();
    }
    elsif ($query->param("create_repos") ne '')
    {
	$db = open_db();
	&create_repository($db, $query);
    }
    elsif ($query->param("retry_create_repos") ne '')
    {
	&retry_create_repository($query);
    }
    else
    {
	print "<h2>CGI script error: action not found.</h2>\n";
    }
}

sub open_db
{
    my($db);

    $db = $MTk::DBClass->new();
    $db or die "Cannot connect to database\n";
    
    $db->open();

    return $db;
}

#
# Make sure that this is a valid repository.
#

sub validate_repository
{
    my($db, $repos_name) = @_;
    my($q, $official_name);

    $q = $db->query("select official_name from Repository where name = '$repos_name'");
    $q or die "Repository $repos_name not found\n";

    $official_name = $q->item(0, 0);
#    print "Listing assets in repository $official_name\n";
}

sub admin_top
{
    my($db) = @_;
    my($page, $repos, $tbl);
    my($q, $i, $repos, $long, $row);

    $page = new PageTemplate("admin_top")->load();

    $tbl = "<table>\n";

    $tbl .= "<tr>\n";
    $tbl .= "<td>Create a new repository</td>\n";
    $tbl .= "<td>" . submit_button("show_create_form", "Create") . "</td>\n";
    $tbl .= "</tr>\n";

    $q = $db->query("select name, official_name from Repository",
		   'name', 'long');

    for $row (@{$q->row_lists()})
    {
	my($base);
	($repos, $long) = @$row;
	$base = repository_base_url($db, $repos);
	$tbl .= "<tr>\n";
	$tbl .= "<td>$long</td>\n";
#	$tbl .=  "<td>" . submit_button("admin_repos_$repos", "Administer $repos") . "</td>\n";
	$tbl .= "<td><a href=\"$base/toc.html\">Go to catalog</a></td>\n";
	$tbl .= "<td><a href=\"$CGIBin/list-assets-cgi/$repos\">List assets</a></td>\n";
	$tbl .=  "</tr>\n";
    }

    $tbl .= "</table>\n";

    $page->replace("#REPOS_TABLE#", $tbl);
    $page->print();

}

sub repository_base_url
{
    my($db, $repos_name) = @_;
    my($q, $url);

    $q = $db->query("select base_url from Repository where name = '$repos_name'");
    $url = $q->item(0, 0);
    return $url;
}

sub submit_button
{
    my($name, $value) = @_;

    return "<input type=submit name=\"$name\" value=\"$value\">";
}

sub show_create_form
{
#    my() = @_;
    my($page) = @_;

    $page = new PageTemplate("new_repository")->load();
    $page->replace("#repos_long_name#", '');
    $page->replace("#repos_name#", '');
    $page->replace("#base_url#", '');
    $page->replace("#base_path#", '');
    $page->print();
}

sub create_repository
{
    my($db, $query) = @_;
    my($repos_name, $repos_long_name, $base_path, $base_url);
    my(@errors, $q);

 CREATE: {
	$repos_long_name = $query->param("repos_long_name");
	$repos_name = $query->param("repos_name");
	$base_path = $query->param("base_path");
	$base_url = $query->param("base_url");
	
	if ($repos_long_name eq '')
	{
	    push(@errors, "Long name for repository is missing");
	}
	$repos_name =~ s/^\s+//;
	$repos_name =~ s/\s+$//;
	
	if ($repos_name eq '')
	{
	    push(@errors, "Short name for repository is missing");
	}
	elsif ($repos_name =~ /\s/)
	{
	    push(@errors, "Short name for repository must not contain spaces");
	}

	$q = $db->query("select official_name from Repository where name = '$repos_name'");

	if ($q)
	{
	    push(@errors, "Repository shortname <i>$repos_name</i> already used for repository <i>" . $q->item(0, 0) . "</i>");
	    last CREATE;
	}

	if ($base_path !~ m,^/,)
	{
	    push(@errors, "Base path must be a fully qualified pathname");
	}
	
	if ($base_url !~ m,^http://,)
	{
	    push(@errors, "Base URL must be an absolute URL\n");
	}

	last CREATE if @errors;
	
	#
	# Don't allow an overwrite of an existing directory
	#
	if (! -d $base_path)
	{
	    eval { mkpath($base_path, 0, 0775); };
	    
	    if ($@)
	    {
		push(@errors, "Creation of $base_path failed: $@");
		last CREATE;
	    }
	    
	    if (! -d $base_path)
	    {
		push(@errors, "Creation of $base_path failed");
		last CREATE;
	    }
	}

	$q = $db->query(<<END);
	INSERT INTO Repository
	    VALUES ('$repos_name',
		    '$repos_long_name',
		    '$base_path',
		    '$base_url')
END
        if ($q)
	{
	    push(@errors, "Database insert failed");
	    last CREATE;
	}
    }
	
    if (@errors)
    {
	my($v);
	
	print "Error", @errors > 1 ? "s " : " ", "in repository creation:\n";
	print "<ul>\n";
	map { print "<li>$_\n"; } @errors;
	print "</ul>\n";
	print "<form action=\"$CGIBin/repos-admin\" method=\"POST\">\n";
	print "<input type=submit name=\"retry_create_repos\" value=\"Return to creation form\">\n";
	print "<input type=submit name=\"admin_top\" value=\"Return to repository administrator\"><br>\n";
	print "<input type=hidden name=\"repos_name\" value=\"$repos_name\">\n";
	print "<input type=hidden name=\"repos_long_name\" value=\"$repos_long_name\">\n";
	print "<input type=hidden name=\"base_path\" value=\"$base_path\">\n";
	print "<input type=hidden name=\"base_url\" value=\"$base_url\">\n";
	print "</form>\n";
	return;
    }

    print "Repository $repos_name creation successful<p>\n";
    my $top = get_top_url($db);
    print "<a href=\"$CGIBin/list-assets-cgi/$repos_name\">Go to asset listing for $repos_long_name</a><p>\n";
    print "<a href=\"$top\">Back to repository administrator</a>\n";
}

sub get_top_url
{
    my($db) = @_;
    my($q, $top);

    $q = $db->query("select admin_url from InstallInfo");
    $top = $q->item(0, 0);
    return $top;
}

sub retry_create_repository
{
    my($query) = @_;
    my($repos_name, $repos_long_name, $base_path, $base_url);
    my($page);

    $repos_long_name = $query->param("repos_long_name");
    $repos_name = $query->param("repos_name");
    $base_path = $query->param("base_path");
    $base_url = $query->param("base_url");

    $page = new PageTemplate("new_repository")->load();
    $page->replace("#repos_long_name#", $repos_long_name);
    $page->replace("#repos_name#", $repos_name);
    $page->replace("#base_url#", $base_url);
    $page->replace("#base_path#", $base_path);

    $page->print();
}
!NO!SUBS!
