use Config;
use File::Basename qw(basename dirname);
chdir(dirname($0));

$perl = shift(@ARGV);

$use = "use lib qw(\n\t" . join("\n\t", @ARGV) . ");\n";

($file = basename($0)) =~ s/\.PL$//;
$file =~ s/\.pl$//
	if ($Config{'osname'} eq 'VMS' or
	    $Config{'osname'} eq 'OS2');  # "case-forgiving"


open OUT,">$file" or die "Can't create $file: $!";
chmod(0755, $file);
print "Extracting $file (with variable substitutions)\n";

print OUT <<"!GROK!THIS!";
#!$perl

#
# Warning: File automatically generated. Any changes made here
# will be lost.
#

$use

##HeaderEnd

!GROK!THIS!
print OUT <<'!NO!SUBS!';



use strict;

use CGI;
use MTk;
use LWP::RobotUA;
use PageTemplate;
require SGS;

my $CGIBin = $MTk::cgi_bin_url;
my $AssetDir = "/home/olson/public_html/nse";
my $AssetBaseURL = "http://www.mcs.anl.gov/~olson/nse";
$::TEMPLATE_DIR = "$MTk::install_lib/templates";

#
# Items in asset creation form.
#

my %BIDMReverseMap;
my %BIDMMap = (asset_title =>
	       [meta => "BIDM.asset.name"],
	       asset_titleline =>
	       [meta => "NHSE.asset.titleline"],
	       asset_url =>
	       [link => "NHSE.asset.webpage"],
	       asset_version =>
	       [meta => "BIDM.asset.version"],
	       asset_abstract =>
	       [meta => "BIDM.asset.abstract"],
	       asset_environment =>
	       [meta => "BIDM.asset.targetenvironment"],
	       asset_repository =>
	       [link => "BIDM.asset.islocatedin.library"],
	       asset_comments =>
	       [meta => "NHSE.asset.comments"],
	       asset_domain =>
	       [meta => "BIDM.asset.domain"],
	       asset_keyword => [meta => "BIDM.asset.keyword"],
	       asset_language => [meta => "BIDM.asset.language"],
	       maintainer_name =>
	       [meta => "NHSE.asset.recordmaintainer.organization.name"],
	       maintainer_address =>
	       [meta => "NHSE.asset.recordmaintainer.organization.address"],
	       maintainer_email =>
	       [meta => "NHSE.asset.recordmaintainer.organization.email"],
	       maintainer_fax =>
	       [meta => "NHSE.asset.recordmaintainer.organization.fax"],
	       maintainer_telephone =>
	       [meta => "NHSE.asset.recordmaintainer.organization.telephone"],
	       contact_name =>
	       [meta => "NHSE.asset.contactis.organization.1.name"],
	       contact_address =>
	       [meta => "NHSE.asset.contactis.organization.1.address"],
	       contact_email =>
	       [meta => "NHSE.asset.contactis.organization.1.email"],
	       contact_fax =>
	       [meta => "NHSE.asset.contactis.organization.1.fax"],
	       contact_telephone =>
	       [meta => "NHSE.asset.contactis.organization.1.telephone"],
	   );

#
# Stuff for the domains thingie. need a more general way to
# define multiple-value form elements.
#
my @Domains = (
	       "application",
	       "benchmark",
	       "data analysis visualization",
	       "distributed processing tool",
	       "educational",
	       "numerical/computational geometry",
	       "numerical/linear algebra",
	       "numerical/optimization",
	       "numerical/PDEs",
	       "numerical/miscellaneous",
	       "parallel processing tool/communication library",
	       "parallel processing tool/execution performance analyzer",
	       "parallel processing tool/parallel programming environment",
	       "parallel processing tool/parallel I/O system",
	       "parallel processing tool/parallel programming language compiler",
	       "parallel processing tool/parallel programming library",
	       "parallel processing tool/parallel runtime system",
"parallel processing tool/source code analyzer restructurer",
"parallel processing tool/miscellaneous",
		 );

eval {
    &main;
};

if ($@)
{
    print "list-assets failed:\n\t$@\n";
    exit(1);
}


exit(0);

sub main
{
    my($db, $asset_id, $repos_name);
    my($query);

    $query = new CGI;

    if ($ENV{'REQUEST_METHOD'} eq "GET")
    {
	my($j);
	($j, $repos_name, $asset_id) = split(/\//, $query->path_info(), 3);
	$asset_id =~ s,\001,//,g;
	$query->param("show", "yes");
    }
    else
    {
	$repos_name = $query->param("repos_name");
	$asset_id = $query->param("asset_id");
    }
    
    $db = $MTk::DBClass->new();
    $db or die "Cannot connect to database\n";
    
    $db->open();

    &validate_repository($db, $repos_name);

    print "Content-type: text/html\n\n";

    if ($query->param("update") ne '')
    {
	my($force);

	$force = ($query->param("force_update") =~ /on/i);
	&update($db, $repos_name, $asset_id, $force);
    }
    elsif ($query->param("delete") ne '')
    {
	if ($query->param("really_delete") eq "yes")
	{
	    &delete_asset($db, $repos_name, $asset_id);
	}
	else
	{
	    &confirm_delete($db, $repos_name, $asset_id);
	}
    }
    elsif ($query->param("add") ne '')
    {
	my($new_url);
	$new_url = $query->param("new_url");
	if ($new_url ne '')
	{
	    &add_asset($db, $repos_name, $new_url);
	}
	else
	{
	    &show_add_form($db, $repos_name, $asset_id);
	}
    }
    elsif ($query->param("show") ne '')
    {
	&show_asset($db, $repos_name, $asset_id);
    }
    elsif ($query->param("gen_catalog") ne '')
    {
	&gen_catalog($db, $repos_name);
    }
    elsif ($query->param("show_create_form") ne '')
    {
	&show_create_form($db, $repos_name);
    }
    elsif ($query->param("new_asset") ne '')
    {
	&new_asset($db, $repos_name, $query);
    }
    elsif ($query->param("show_edit_form") ne '')
    {
	&show_edit_form($db, $repos_name, $asset_id);
    }
    elsif ($query->param("edit_asset") ne '')
    {
	&edit_asset($db, $repos_name, $asset_id, $query);
    }
    elsif ($query->param("show_search_form") ne '')
    {
	my($string);
	$string = $query->param("search_string");
	&search($db, $repos_name, $string);
    }
    else
    {
	print "<h2>CGI script error: action not found.</h2>\n";
    }
}

#
# Make sure that this is a valid repository.
#

sub validate_repository
{
    my($db, $repos_name) = @_;
    my($q, $official_name);

    $q = $db->query("select official_name from Repository where name = '$repos_name'");
    $q or die "Repository $repos_name not found\n";

    $official_name = $q->item(0, 0);
#    print "Listing assets in repository $official_name\n";
}

sub gen_catalog
{
    my($db, $repos_name) = @_;
    my($q, $url);

    $| = 1;

    print <<END;
<html>
<head>
<title>Regenerating catalog</title>
</head>
<body>
<h1>Regenerating catalog</h1>
Please wait ... <p>
END

    run_child("/home/olson/nse/RIB/install/bin/gen-catalog", $repos_name);

    print "Done<p>\n";

    $url = repository_base_url($db, $repos_name);

    print "<a href=\"$url/toc.html\">Go to the catalog</a><br>\n";
print "<a href=\"$CGIBin/list-assets-cgi/$repos_name\">Return to repository asset listing</a><br>\n";
    print "</body></html>\n";
}

sub repository_base_url
{
    my($db, $repos_name) = @_;
    my($q, $url);

    $q = $db->query("select base_url from Repository where name = '$repos_name'");
    $url = $q->item(0, 0);
    return $url;
}

sub run_child
{
    my(@args) = @_;
    my($r, $w, $child);

    ($r, $w) = FileHandle::pipe();
    select((select($w), $| = 1)[0]);

    $| = 1;

    $child = fork;
    if (!defined($child))
    {
	die "Fork failed! !$\n";
    }
    if ($child == 0)
    {
	close(STDOUT);
	close(STDERR);
	my $f = fileno($w);
	close($r);
	open(STDOUT, ">&$f");
	open(STDERR, ">&$f");
	close($w);
	exec(@args);
	die "exec failed: $!\n";
    }

    close($w);

    while (<$r>)
    {
	chop;
	print "$_<p>\n";
    }
    close($r);
    wait;
}

sub update
{
    my($db, $repos_name, $asset_id, $force) = @_;
    my($user_agent);
    my($q, $asset, $a);
    
    $user_agent = new LWP::RobotUA("RIB/0.1", "olson\@mcs.anl.gov");
    $user_agent->delay(0);

    $asset = MTk::DBTable::Asset->new($asset_id, $db);
    if (!$asset->fetch())
    {
	print "Asset not found\n";
	return;
    }

    $| = 1;

    print <<END;
<html>
<head>
<title>Asset update response</title>
</head>
<body>

Retrieving asset $asset_id.<p>
END

    if ($force)
    {
	$asset->field_value('last_retrieval', -1);
    }

    my($bidm_tagset, $response) = $asset->retrieve_metadata($user_agent);

    print "Received webpage<p>\n";

    if ($bidm_tagset)
    {

	$asset->store_tagset($bidm_tagset);
	print "<p>Retrieval of asset $asset_id successful<p>\n";
    }
    else
    {
	my($code, $msg);
	$code = $response->code();
	$msg = $response->message();
	print "Retrieval of asset $asset_id failed with response code $code: $msg<p>\n";
    }

    my($qid);
    ($qid = $asset_id) =~ s,//,%01,g;
    print "<a href=\"$CGIBin/show-asset-form-action/$repos_name/$qid\">Return to asset description page</a>\n";
    print "</body></html>\n";
}

sub confirm_delete
{
    my($db, $repos_name, $asset_id) = @_;

    print <<END;
<html>
<head>
<title>Deletion confirmation</title>
</head>
<body>
<H1> Deletion confirmation</h1>
Really delete asset $asset_id?<p>
<form action=\"$CGIBin/show-asset-form-action\" method=\"POST\">

<input type=\"hidden\" name=\"repos_name\" value=\"$repos_name\">
<input type=\"hidden\" name=\"asset_id\" value=\"$asset_id\">
<input type=\"hidden\" name=\"really_delete" value=\"yes\">
<input type=\"submit\" name=\"delete\" value=\"Yes, really delete\">
<p>
<input type=\"submit\" name=\"show\" value=\"No, don't delete\">
</form>
</body>
</html>
END
}

sub show_add_form
{
    my($db, $repos_name, $cur_asset) = @_;

    print <<END;
<html>
<head>
<title>Add an asset</title>
</head>
<body>
<H1>Add an asset</h1>

<form action=\"$CGIBin/show-asset-form-action\" method=\"POST\">

Asset URL:
<input type=\"text\" size=\"50\" maxlength=\"300\" name=\"new_url\">
<input type=\"hidden\" name=\"repos_name\" value=\"$repos_name\">
<p>
<input type=\"reset\" value=\"Reset form\">
<input type=\"submit\" name=\"add\" value=\"Add this asset\">
</form>
END
    if ($cur_asset ne '')
    {
	my($qid);
	($qid = $cur_asset) =~ s,//,%01,g;
	print "<a href=\"$CGIBin/show-asset-form-action/$repos_name/$qid\">Return to asset description page</a><br>\n";
    }
    print "<a href=\"$CGIBin/list-assets-cgi/$repos_name\">Return to repository asset listing</a><br>\n";

    print <<END;
</body>
</html>
END
}

sub add_asset
{
    my($db, $repos_name, $asset_url) = @_;
    my($asset, $rc);
    my($q);

    $asset = MTk::DBTable::Asset->new($asset_url, $db);
    
    #
    # First see if it's already there
    #

    $rc = $asset->fetch();

    if ($rc)
    {
	print "Asset $asset_url already present\n";
	return;
    }

    $asset->field_value('repository', $repos_name);
    $asset->field_value('expires', 4);
    $asset->field_value('last_retrieval', -1);
    $asset->field_value('last_modified', -1);

    $asset->store();

    print "Asset $asset_url added to repository<p>\n";
    my($qid);
    $qid = $asset_url;
    $qid =~ s,//,%01,g;
    print "<a href=\"$CGIBin/show-asset-form-action/$repos_name/$qid\">Show this asset</a><br>\n";
    print "<a href=\"$CGIBin/list-assets-cgi/$repos_name\">Return to repository asset listing</a><br>\n";
}

sub delete_asset
{
    my($db, $repos_name, $asset_url) = @_;
    my($asset, $rc);
    my($q);

    $asset = MTk::DBTable::Asset->new($asset_url, $db);
    
    #
    # First see if it's already there
    #

    $rc = $asset->fetch();

    if (!$rc)
    {
	print "Asset $asset_url not present in database\n";
	return;
    }

    $db->query("delete from Asset where id = '$asset_url'");
    $db->query("delete from Tag where asset_id = '$asset_url'");

    print "Asset $asset_url deleted<p>\n";
    print "<a href=\"$CGIBin/list-assets-cgi/$repos_name\">Return to repository asset listing</a><br>\n";
}

sub show_asset
{
    my($db, $repos_name, $asset_id) = @_;
    my($q, $asset, $a);
    my($id, $repos, $exp, $last_retr);
    
    $asset = MTk::DBTable::Asset->new($asset_id, $db);
    if (!$asset->fetch())
    {
	print "Asset not found\n";
	return;
    }

    my($fname, $fvalue);
    print "<h3>Asset information</h3>\n";
    print "<table>\n";
    print "<tr> <td>Id</td><td>", $asset->field_value("id"), "</td></tr>\n";
    print "<tr><td>Last retrieval</td><td>", fmt_time($asset->field_value("last_retrieval")), "</td></tr>\n";
    print "<tr><td>Last modification of asset</td><td>", fmt_time($asset->field_value("last_modified")), "</td></tr>\n";
    print "</table>\n";
    
#     print "<h3>Database fields</h3>\n";
#     print "<dl>\n";
#     for $fname ($asset->field_names())
#     {
# 	$fvalue = $asset->field_value($fname);
# 	print "<dt> $fname\n";
# 	print "<dd> $fvalue\n";
#     }
#     print "</dl>\n";

    print <<END;
<hr>
<form action=\"$CGIBin/show-asset-form-action\" method=\"POST\">

<input type=\"hidden\" name=\"repos_name\" value=\"$repos_name\">
<input type=\"hidden\" name=\"asset_id\" value=\"$asset_id\">
<table border=0>
<tr>
<td>
<input type=\"submit\" name=\"update\" value=\"Update asset\">
</td>
<td>
<input type=\"submit\" name=\"delete\" value=\"Delete asset\">
</td>
<td>
<input type=\"submit\" name=\"show_edit_form\" value=\"Edit asset\">
</td>
</tr>
<tr>
<td>
Force update <input type=\"checkbox\" name=\"force_update\">
</td>
<td>
<input type=\"submit\" name=\"add\" value=\"Add an asset\">
</td>
<td>
<input type=\"submit\" name=\"show\" value=\"Redisplay asset\">
</td>
</tr>
</table>
<a href=\"$CGIBin/list-assets-cgi/$repos_name\">Return to repository asset listing</a>
</form>
<hr>
END

    my $ts = new BIDM::Tagset;
    $ts->load_from_db($db, $asset_id);

    print "<h3>Asset tags (from database)</h3>\n";

    my($attrs, $tag, $val, $bidm_tag);
    print "<table border=1>\n";
    print "<tr><th>Type</th><th>Tag</th><th>Contents</th></tr>\n";
    for $tag (@{$ts->{tags}})
    {
	$attrs = $tag->{attributes};
	if ($tag->{type} = 'meta')
	{
	    $bidm_tag = $attrs->{name};
	    $val = $attrs->{content};
	}
	else
	{
	    $bidm_tag = $attrs->{rel};
	    $val = $attrs->{href};
	}

	next if $bidm_tag =~ /^\s*$/;
	print "<tr>\n";

	print "<td>$tag->{type}</td>\n";
	print "<td>$bidm_tag</td>\n";
	print "<td>$val</td>\n";

	print "</tr>\n";
    }
    print "</table>\n";

#     print "<h3>Raw tag data from database</h3>\n";
    
#     print "<pre>\n";
#     $ts->print();
#     print "</pre>\n";

#     my $obj = $ts->parse();

#     print "<dl>\n";
#     if ($obj)
#     {
# 	print "<h3>Parsed object data</h3>\n";
# 	$obj->walk();
#     }
}

sub fmt_time
{
    my($time) = @_;
    my @days = qw(Sun Mon Tue Wed Thu Fri Sat);    
    my @months = qw(Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec);

    my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) =
	localtime($time);

    my $day = $days[$wday];
    my $month = $months[$mon];

    return sprintf("%02d:%02d:%02d $month %2d, 19$year\n",
		   $hour, $min, $sec, $mday);

}

sub show_create_form
{
    my($db, $repos_name) = @_;
    my($page, $item);

    $page = new PageTemplate('submit_form')->load();

    for $item (keys %BIDMMap)
    {
	$page->replace("#$item#", "");
    }
    $page->replace("#repos_name", $repos_name);
    $page->replace("#return_to_listing#",
		   "$CGIBin/list-assets-cgi/$repos_name");
    $page->print();
}

sub new_asset
{
    my($db, $repos_name, $query) = @_;
    my($item, %item, $id, $file, $fh, $val, $tag);

#    print "new_asset $repos_name<br>\n";
#    print "<ul>\n";
#    for $item (@AssetCreationItems)
#    {
#	$item{$item} = $query->param($item);
#	print "<li> <b>$item</b>: $item{$item}\n";
#    }
#     for $item (keys(%BIDMMap))
#     {
# 	$tag = join(":", @{$BIDMMap{$item}});
# 	print "<li> <b>$item</b> <i>$tag</i> \n";
# 	if (($val = $query->param($item)) ne '')
# 	{
# 	    print "<li> $val\n";
# 	}
#     }
#     print "</ul>\n";

#    if (!check_for_required_items($query))
#    {
#	print "Invalid form, missing some required items?<br>\n";
#	return;
#    }

    $id = alloc_asset_id($MTk::DB::DBI::ServerHost,
			 $MTk::DB::DBI::DBName);
    $file = "$AssetDir/asset_$id.html";
    
    $fh = new FileHandle(">$file");
    $fh or die "Cannot create $file: $!\n";
    my $url = "$AssetBaseURL/asset_$id.html";
    write_asset($fh, $query);
    print "Created asset $url<p>\n";
    $fh->close();
    add_asset($db, $repos_name, $url);
    silent_update($db, $repos_name, $url);
}

sub edit_asset
{
    my($db, $repos_name, $asset_id, $query) = @_;
    my($item, %item, $id, $file, $fh, $val, $tag);

    $file = $query->param("asset_file");

    print "edit_asset $repos_name file=$file<br>\n";

    $fh = new FileHandle(">$file");
    $fh or die "Cannot create $file: $!\n";
    write_asset($fh, $query);
    $fh->close();

    silent_update($db, $repos_name, $asset_id);
    show_asset($db, $repos_name, $asset_id);
}

sub silent_update
{
    my($db, $repos_name, $asset_id) = @_;
    my($user_agent, $asset);
    
    $user_agent = new LWP::RobotUA("RIB/0.1", "olson\@mcs.anl.gov");
    $user_agent->delay(0);

    $asset = MTk::DBTable::Asset->new($asset_id, $db);
    if (!$asset->fetch())
    {
	print "Asset not found\n";
	return;
    }

    $| = 1;

    my($bidm_tagset, $response) = $asset->retrieve_metadata($user_agent);

    if ($bidm_tagset)
    {
	$asset->store_tagset($bidm_tagset);
    }
}

sub check_for_required_items
{
    my($query) = @_;

    return 0 if $query->param("title") eq '';
    return 0 if $query->param("record_maintainer") eq '';
    return 1;
}

sub write_asset
{
    my($fh, $query) = @_;
    my($item, $bidm_tag_rec, $bidm_tag, $type, $val);
    my($title);

    $title = $query->param("title");

    print $fh (<<END);
<html>
<head>
<title>$title</title>
END

    while (($item, $bidm_tag_rec) = each(%BIDMMap))
    {
	if (($val = $query->param($item)) ne '')
	{
	    ($type, $bidm_tag) = @$bidm_tag_rec;

	    if ($type eq 'meta')
	    {
		if ($item eq 'asset_domain')
		{
		    $val =~ s/^.*:\s*([^:]+)\s*$/\1/g;
		}
		print $fh "<meta name=\"$bidm_tag\"\n";
		print $fh "      content=\"$val\">\n";
	    }
	    else
	    {
		print $fh "<link rel=\"$bidm_tag\"\n";
		print $fh "      href=\"$val\">\n";
	    }
	}
    }
    print $fh (<<END);
</head>
<body>
</body>
</html>
END
}

sub show_edit_form
{
    my($db, $repos_name, $asset_id) = @_;
    my($file, $page, $asset, @other_items);

    if ($asset_id =~ m,^$AssetBaseURL/(.*),)
    {
	$file = "$AssetDir/$1";

	if (-f $file)
	{
#	    print "Got asset file $file\n";
	}
	else
	{
	    print "Asset file $file not found, aborting edit\n";
	    return;
	}
    }

    #
    # Retrieve the asset tag data, and initialize the form.
    #

    my($tagset, $tag, %replaced, $item);
    $tagset = new BIDM::Tagset;
    $tagset->load_from_db($db, $asset_id);

#    print "Loaded tagset $tagset<p>";

    $page = new PageTemplate('edit_form')->load();

    $page->replace("#ASSET_ID#", $asset_id);
    $page->replace("#ASSET_FILE#", $file);
    $page->replace("#REPOS_NAME#", $repos_name);
    $page->replace("#return_to_listing#",
		   "$CGIBin/list-assets-cgi/$repos_name");

    build_reverse_map();

    for $tag (@{$tagset->{tags}})
    {
	my($attrs, $k, $v, $bidm_tag, $form_item, $type, $val);
	$attrs = $tag->{attributes};

#	print "Tag $tag type=$tag->{type}<br>\n";

	if ($tag->{type} eq 'meta')
	{
	    $bidm_tag = $attrs->{name};
	    $val = $attrs->{content};
	    my $rec = $BIDMReverseMap{$bidm_tag};

	    if (ref($rec))
	    {
		($type, $form_item) = @$rec;

		#
		# Domain is special
		#
		
		if ($form_item eq "asset_domain")
		{
		    my $str = build_domain_form_element($val);
		    $page->replace("#DOMAINS#", $str);
		}
		else
		{
		    $page->replace("#$form_item#", $val);
		}
		$replaced{$form_item}++;
	    }
	    else
	    {
		push(@other_items, $tag);
	    }
	}
	else
	{
	    $bidm_tag = $attrs->{rel};
	    $val = $attrs->{href};
	    my $rec = $BIDMReverseMap{$bidm_tag};

	    if (ref($rec))
	    {
		($type, $form_item) = @$rec;
		$page->replace("#$form_item#", $val);
		$replaced{$form_item}++;
	    }
	    else
	    {
		push(@other_items, $tag);
	    }
	}
    }

    #
    # Now empty out the items that weren't replaced
    #

    for $item (keys %BIDMMap)
    {
	next if $replaced{$item};
	$page->replace("#$item#", "");
    }

    #
    # Handle the tags that we don't have specific form items for.
    #

    my $other;

    $other = "<table>\n";
    for $tag (@other_items)
    {
	$other .= handle_other_tag($tag);
    }
    $other .= "</table>\n";

    $page->replace("#OTHER_ITEMS#", $other);

    #
    # And dump the form.
    #
    $page->print();

#    print "<p>other items: @other_items\n$other\n";
}

sub handle_other_tag
{
    my($tag) = @_;
    my($attrs, $bidm_tag, $val, $txt);
    my($lines, $rows);

    $attrs = $tag->{attributes};

    if ($tag->{type} eq 'meta')
    {
	$bidm_tag = $attrs->{name};
	$val = $attrs->{content};
    }
    else
    {
	$bidm_tag = $attrs->{rel};
	$val = $attrs->{href};
    }

    $lines = $val =~ tr/\n/\n/;
    $rows = $lines > 1 ? 2 : 1;
    $txt = "<tr>\n";
    $txt .= "<td>\n";
    $txt .= "$bidm_tag\n";
    $txt .= "</td>\n";
    $txt .= "<td>\n";
    $txt .= "<textarea rows=$rows cols=40 name=\"$bidm_tag\">\n";
    $txt .= $val;
    $txt .= "</textarea>\n";
    $txt .= "<input type=\"hidden\" name=\"TYPE_$bidm_tag\" value=\"$tag->{type}\">\n";
    $txt .= "</td>\n";
    $txt .= "</tr>\n";

    return $txt;
}
    
sub build_domain_form_element
{
    my($selected) = @_;
    my($str, $d);

    $str = "Domain: <select name=\"asset_domain\" size=1>\n";
    for $d (@Domains)
    {
	$str .= "<option";
	if ($d eq $selected)
	{
	    $str .= " selected";
	}
	$str .= ">$d</option>\n";
    }
    $str .= "</select>";
}

sub build_reverse_map
{
    my($form_item, $vrec, $type, $bidm_tag);

    while (($form_item, $vrec) = each(%BIDMMap))
    {
	($type, $bidm_tag) = @$vrec;
	$BIDMReverseMap{$bidm_tag} = [$type, $form_item];
    }
}
    

sub alloc_asset_id
{
    my($host, $dbname) = @_;
    SGS::SetHostname($host);

    return sgs_get_id("${dbname}::asset");
}

sub sgs_get_id
{
    my($seq) = @_;
    my($rc, $val, $sname);

    $sname = "$seq";

#    print "call sgs::nxtvalue $sname\n";
    ($rc, $val) = SGS::NextValue($sname);
#    print "Returns $rc $val\n";
    if ($rc == 0)
    {
	#
	# Try creating the sequence, then try again
	#
	if (SGS::CreateSequence($sname) != 1)
	{
	    die "SGS::CreateSequence $sname failed\n";
	}
	($rc, $val) = SGS::NextValue($sname);
	if ($rc == 0)
	{
	    die "SGS::NextValue $sname  failed";
	}
    }
    return $val;
}

sub search
{
    my($db, $repos_name, $string) = @_;
    my($q, $name, $url, $i, $official_name);

    $official_name = validate_repository($db, $repos_name);
    
    print <<END;
<html>
<head>
<title>Search results for $official_name</title>
</head>
<body>
<h1>Search results for <i>$string</i> in $official_name</h1>
END

    $string =~ s/^\s+//;
    $string =~ s/\s+$//;

    if ($string eq '')
    {
	print "<i>Please enter a non-blank search string</i>\n";
	return;
    }

    $string =~ s/([A-Za-z])/\[\L$1\U$1\]/gi;

#    if ($what eq "Name")
#    {
#	$cond = "AND attr_key = 'name' AND
#    }
#    $cond = "attr_key = 
    
    $q = $db->query(<<END);
	SELECT DISTINCT 
		c.name, c.catalog_url
	FROM
		Tag t, Catalog c
	WHERE
		t.attr_value like '%$string%' AND
		t.asset_id = c.asset_id AND
		c.repository = '$repos_name'
END

    if ($q)
    {
	my(%out);
	
	print "<table border=1>\n";
	for ($i = 0; $i < $q->n_rows(); $i++)
	{
	    $name = $q->item($i, 0);
	    $url = $q->item($i, 1);
	    $out{$name} = $url;
	}

	for $name (sort { $a cmp $b } keys(%out))
	{
	    $url = $out{$name};
	    print "<tr>\n";
	    print "<td>$name</td>\n";
	    print "<td><a href=\"$url\">$url</a></td>\n";
	    print "</tr>\n";
	    #	print "Name: $name url: $url<br>\n";
	}
	print "</table>\n";
    }
    else
    {
	print "<i>No matches found</i>\n";
    }

    print "</body></html>\n";

}

package BIDM::RIGObject;
sub walk
{
    my($self) = @_;
#    print "RIG walk $self\n";
}

package BIDM::RIGObject::Asset;
sub walk
{
    my($self) = @_;
    my($name, $k);

    print "<dt>Domain <dd> ", $self->Domain(), "\n";
    
    for $k ($self->Keyword())
    {
	print "<dt>Keyword <dd> $k\n";
    }
    print "<dt>Abstract <dd>", $self->Abstract(), "\n";
}

package BIDM::RIGObject::Organization;
sub walk
{
    my($self) = @_;
#    print "Organization walk $self\n";
}

package BIDM::RIGObject::Library;
sub walk
{
    my($self) = @_;
#    print "Library walk $self\n";
}

!NO!SUBS!
