
package PageTemplate;

#
# A PageTemplate is used to provide a simple interface for
# template substitution from a FrontPage-edited page from a CGI
# script.
#

#
# new(template-name)
#
sub new
{
    my($class, $name) = @_;
    my $self;
    $self = {
	name => $name,
    };

    my(@search_path, $dir);
    @search_path = ($::TEMPLATE_DIR, @INC);
    for $dir (@search_path)
    {
	if (-f ($p = "$dir/$name.htm"))
	{
	    $self->{path} = $p;
	    last;
	}
	elsif (-f ($p = "$dir/$name.html"))
	{
	    $self->{path} = $p;
	    last;
	}
	elsif (-f ($p = "$dir/templates/$name.htm"))
	{
	    $self->{path} = $p;
	    last;
	}
	elsif (-f ($p = "$dir/templates/$name.html"))
	{
	    $self->{path} = $p;
	    last;
	}
    }

#    print "Found templ in $self->{path}\n";
    
    if (! -f $self->{path})
    {
	die "Template $name not found\n";
    }
    return bless($self, $class);
}

#
# load()
#
# Create another instance of the template, and load the page into it.
#
sub load
{
    my($self) = @_;
    my($new);
    local(*F);
    
    $new = new PageTemplate($self->{name});

    open(F, "<$new->{path}") or
	die "Cannot open template file $new->{path}: $!\n";
    local($/) = undef;
    $new->{page} = <F>;
    close(F);
    return $new;
}

#
# replace(keyword, string)
#
# Replace every instance of keyword with string.
#
sub replace
{
    my($self, $keyword, $string) = @_;

    $self->{page} =~ s/$keyword/$string/g;
}

sub print
{
    my($self, $fh) = @_;

    if (!$fh)
    {
	$fh = \*STDOUT;
    }

    print $fh $self->{page};
}

sub page
{
    my($self) = @_;
    return $self->{page};
}

1;
